package HashWithKeyCheck;

use strict;
use warnings;
#継承するとSUPER::FIRSTKEYが呼ばれてエラーになるので継承しない
#use Tie::Hash;
#use base qw(Tie::StdHash);
use Carp;
use utf8;

sub TIEHASH {
    my ($class,$hash,%arg_opt) = @_;
	my %opt = (
		fetch_check		=>1,
		store_check		=>1
	);
	%opt = (%opt,%arg_opt);
	my $self=\%opt;
	$self->{data}=$hash;
    return  bless $self,$class;
}
sub STORE {
    my ($self, $key,$value) = @_;

    if (($self->{store_check}==1) && (!exists($self->{data}->{$key}))){
        croak sprintf("STORE:key[%s] not exists",$key);
    }
    
    return $self->{data}->{$key} = $value;
}
sub FETCH {
    my ($self, $key) = @_;

    if (($self->{fetch_check}==1) && (!exists($self->{data}->{$key}))){
        croak sprintf("FETCH:key[%s] not exists",$key);
    }
    
    return $self->{data}->{$key};
}
sub EXISTS{
    my ($self, $key) = @_;
    return exists($self->{data}->{$key});	
}
sub FIRSTKEY{
	my $self = shift;
	my $ret = each %{$self->{data}};
	return $ret;
}
sub NEXTKEY{
	my ($self,$lastkey) = @_;
	my $ret = each %{$self->{data}};
	return $ret;
}
sub CLEAR{
	my $self = shift;
	$self->{data}=();
}
sub DELETE{
	my ($self, $key) = @_;
	delete $self->{data}->{$key};
}
1;
